var request = require('request')
process.env.NODE_TLS_REJECT_UNAUTHORIZED = "0";
var host = null;
var storage_path = require('./config').storage_path
var storageprofilepath = require('./config').storageprofilepath
var applicationdatabase_path = require('./config').applicationdatabase_path
var database_path = require('./config').database_path
var setSessionandHeader = require('./helpfunction').setSessionandHeader
var ngp = require('../../ecxngp');
const json2csv = require('json2csv').parse;

var option = {
    method:'GET',
    url:'',
    headers:
        {
            'x-endeavour-sessionid':'',
            'x-endeavour-auditrequest':'yes',
            'Content-Type':'application/json',
            'Accept':'application/json'
        }
};
var snapOption = {
    method:'GET',
    url: '',
    headers:
        {
            'x-endeavour-sessionid':'',
            'x-endeavour-auditrequest':'yes',
            'Content-Type':'application/json',
            'Accept':'application/json'
        },
    qs:
        {
            'filter' : ''
        }
};
var timelen = {"SUBHOURLY":60000,"HOURLY":60*60000,"DAILY":24*60*60000,"WEEKLY":7*24*60*60000,"MONTHLY":30*24*60*60000}
var words ={"SUBHOURLY":"minute(s)","HOURLY":"hour(s)","DAILY":"day(s)","WEEKLY":"week(s)","MONTHLY":"month(s)"}


var SLAbackschedule = {};
var SLArepschedule = {};
var SLAoffschedule = {};
var replicationerrsession = {};
var offloadsession = {};
var backupresult = {};

function getstorageprofile(starturl,resolve,reject)
{
    option.url = starturl
    function loop()
    {
        request( option, function( error, response, body)
        {
            if(!error && response.statusCode == 200)
            {
              var STP = JSON.parse(body).storageprofiles
              var links = JSON.parse(body).links
              for( var i in STP )
              {
                var subpolicies = STP[i].spec.subpolicy
                for( var j in subpolicies )
                {
                    var subp = subpolicies[j]
                    var index = STP[i].id
                    if( subp.type == 'BACKUP')
                    {
                        if(STP[i].name in SLAbackschedule)
                        {
                            SLAbackschedule[STP[i].name][index] = {'freq':subp.trigger.frequency,'schedule': subp.trigger.type}
                        }
                        else
                        {
                            SLAbackschedule[STP[i].name] = {}
                            SLAbackschedule[STP[i].name][index] = {'freq':subp.trigger.frequency,'schedule': subp.trigger.type}                    
                        }
                    }
                     else if( subp.type == 'REPLICATION')
                    {
                        if(STP[i].name in SLArepschedule)
                        {
                            SLArepschedule[STP[i].name][index] = {'freq':subp.trigger.frequency,'schedule': subp.trigger.type}
                        }
                        else
                        {
                            SLArepschedule[STP[i].name] = {}
                            SLArepschedule[STP[i].name][index] = {'freq':subp.trigger.frequency,'schedule': subp.trigger.type}                    
                        }
                    }
                    else if( subp.type == 'SPPOFFLOAD')
                    {
                        if(STP[i].name in SLAoffschedule)
                        {
                            SLAoffschedule[STP[i].name][index] = {'freq':subp.trigger.frequency,'schedule': subp.trigger.type}
                        }
                        else
                        {
                            SLAoffschedule[STP[i].name] = {}
                            SLAoffschedule[STP[i].name][index] = {'freq':subp.trigger.frequency,'schedule': subp.trigger.type}                    
                        }
                    }

                }
              }
                if('nextPage' in links)
                {
                    option.url = links.nextPage.href
                    return loop()
                }
                else
                {
                    console.log(SLAbackschedule,SLAoffschedule,SLArepschedule)
                    return resolve()
                }
            }
            else
            {
                const err = new Error("Error when getting storageprofile")
                err.status = 403
                reject(err);
            }
        }) 
    }
    return loop()
}

function gethyperdbs(starturl,resolve,reject)
{
    option.url = starturl;
    var dblists = {};
    function loop()
    {
        request(option,function(error,response,body){
            if(!error && response.statusCode == 200)
            {
                var links = JSON.parse(body).links
                var body = JSON.parse(body);
                for( var i in body.children )
                {
                    var db = body.children[i]
                    var dbinfo = {}
                    dbinfo['DB'] = db.properties['name']
                    dbinfo['SLAPolicy'] = db.properties.protectionInfo.storageProfileName
                    dbinfo['ProtectionTime'] = db.properties.protectionInfo.protectionTime
                    dbinfo['Frequency'] = dbinfo['SLAPolicy'] in SLAbackschedule && db.properties.protectionInfo.storageProfileId in SLAbackschedule[dbinfo['SLAPolicy']] ? SLAbackschedule[dbinfo['SLAPolicy']][db.properties.protectionInfo.storageProfileId].freq : null
                    dbinfo['Schedule'] = dbinfo['SLAPolicy'] in SLAbackschedule && db.properties.protectionInfo.storageProfileId in SLAbackschedule[dbinfo['SLAPolicy']] ? SLAbackschedule[dbinfo['SLAPolicy']][db.properties.protectionInfo.storageProfileId].schedule : null
                    dblists[db.properties.pk] = dbinfo
                }
                if('nextPage' in links)
                {
                    option.url = links.nextPage.href
                    return loop()
                }
                else
                {
                    console.log(dblists)
                    return resolve(dblists)
                }
            }
            else
            {
                console.error(error)
                const err = new Error("Error while getting sucessful backup records")
                err.status = 403
                return reject(err);
            }
        })
    }
    return loop()
}
function getrecoverydbs(dblists,starturl,resolve,reject)
{
    backupresult.compliance = []
    backupresult.ucompliance = []
    option.url = starturl
    function loop()
    {
        request(option,function(error,response,body){
            if(!error && response.statusCode == 200 )
            {
                var links = JSON.parse(body).links
                var body = JSON.parse(body)
                for( var i in body.children )
                {
                    var db = body.children[i]
                    if(db.properties.errObj.protectionInfo.subPolicyType == 'REPLICATION') {
                        replicationerrsession[db.properties.pk] = db.properties.sessionId
                        continue
                    }
                    else if(db.properties.errObj.protectionInfo.subPolicyType == 'SPPOFFLOAD')
                    {
                        offloadsession[db.properties.pk] = db.properties.sessionId
                        continue
                    }
                    var dbinfo = {}
                    dbinfo['DB'] = db.properties.errObj.name
                    dbinfo['SLAPolicy'] = db.properties.errObj.protectionInfo.storageProfileName
                    if( db.properties.pk in dblists)
                    {
                        var sucdb = dblists[db.properties.pk]
                        if(db.properties.errObj.protectionInfo.protectionTime < sucdb.ProtectionTime)
                        {
                            if( Date.now() - timelen[sucdb.Schedule] * sucdb.Frequency < sucdb.ProtectionTime )
                            {
                                backupresult.compliance.push(sucdb)
                            }
                            else
                            {
                                sucdb['FailureReason'] = "Defined RPO for SLA Policy " + sucdb.SLAPolicy + " to run Every " + sucdb.Frequency +" " +words[sucdb.Schedule] +"not meet."
                                backupresult.ucompliance.push(sucdb)
                            }
                            
                        }
                        else
                        {
                            
                            dbinfo['ProtectionTime'] = sucdb.ProtectionTime
                            dbinfo['Frequency'] = sucdb.Frequency
                            dbinfo['Schedule'] =sucdb.Schedule
                            dbinfo['FailureReason'] = db.properties.errObj.protectionInfo.lastErrorMessage
                            backupresult.ucompliance.push(dbinfo)
                        }
                        delete dblists[db.properties.pk]
                    }
                    else
                    {

                        dbinfo['ProtectionTime'] = 'No Succesful Runs'
                        dbinfo['Frequency'] = dbinfo['SLAPolicy'] in SLAbackschedule && db.properties.errObj.protectionInfo.storageProfileId in SLAbackschedule[dbinfo['SLAPolicy']] ? SLAbackschedule[dbinfo['SLAPolicy']][db.properties.errObj.protectionInfo.storageProfileId].freq : null
                        dbinfo['Schedule'] = dbinfo['SLAPolicy'] in SLAbackschedule && db.properties.errObj.protectionInfo.storageProfileId in SLAbackschedule[dbinfo['SLAPolicy']] ? SLAbackschedule[dbinfo['SLAPolicy']][db.properties.errObj.protectionInfo.storageProfileId].schedule : null
                        dbinfo['FailureReason'] = db.properties.errObj.protectionInfo.lastErrorMessage                       
                        backupresult.ucompliance.push(dbinfo)
                    }
                }
                if('nextPage' in links)
                {
                    option.url = links.nextPage.href
                    return loop()
                }
                else
                {
                    for( var i in dblists )
                    {
                        if( Date.now() - timelen[dblists[i].Schedule] * dblists[i].Frequency < dblists[i].ProtectionTime )
                        {
                            backupresult.compliance.push(dblists[i])
                        }
                        else
                        {
                            dblists[i]['FailureReason'] = "Defined RPO for SLA Policy " + dblists[i].SLAPolicy + " to run Every " + dblists[i].Frequency +" " +words[dblists[i].Schedule] +" not meet."
                            backupresult.ucompliance.push(dblists[i])
                        }
                    }
                    return resolve()
                }
            }
            else
            {
                console.error(error)
                const err = new Error("Error while getting failed backup records")
                err.status = 403
                reject(err);
            }
        })
    }
    return loop()
}
function getdbcompliances(starturl,resolve,reject)
{
    option.url = starturl
    var replicationresult = {}
    var offloadresult = {}
    offloadresult.compliance = []
    offloadresult.ucompliance = []
    replicationresult.compliance = []
    replicationresult.ucompliance = []
    function loop()
    {
        request(option,function(error,response,body){
            if(!error && response.statusCode == 200 )
            {
                var links = JSON.parse(body).links
                var body = JSON.parse(body)
                var promisearray =[]
                for( var i in body.children )
                {
                    var promise = new Promise(function(resolve,reject)
                    {
                        var db = body.children[i]
                        var dbinfo = {}
                        dbinfo['DB'] = db.properties['name']
                        dbinfo['SLAPolicy'] = db.properties.protectionInfo.storageProfileName
                        if(db.properties.protectionInfo.storageProfileName in SLArepschedule && db.properties.protectionInfo.storageProfileId in SLArepschedule[db.properties.protectionInfo.storageProfileName] )
                        {
                            dbinfo['RepFrequency'] = dbinfo['SLAPolicy'] in SLArepschedule && db.properties.protectionInfo.storageProfileId in SLArepschedule[dbinfo['SLAPolicy']] ? SLArepschedule[dbinfo['SLAPolicy']][db.properties.protectionInfo.storageProfileId].freq : null
                            dbinfo['RepSchedule'] = dbinfo['SLAPolicy'] in SLArepschedule && db.properties.protectionInfo.storageProfileId in SLArepschedule[dbinfo['SLAPolicy']] ? SLArepschedule[dbinfo['SLAPolicy']][db.properties.protectionInfo.storageProfileId].schedule : null
                        }
                        if(db.properties.protectionInfo.storageProfileName in SLAoffschedule && db.properties.protectionInfo.storageProfileId in SLAoffschedule[db.properties.protectionInfo.storageProfileName] )
                        {
                            dbinfo['OffFrequency'] = dbinfo['SLAPolicy'] in SLAoffschedule && db.properties.protectionInfo.storageProfileId in SLAoffschedule[dbinfo['SLAPolicy']] ? SLAoffschedule[dbinfo['SLAPolicy']][db.properties.protectionInfo.storageProfileId].freq : null
                            dbinfo['OffSchedule'] = dbinfo['SLAPolicy'] in SLAoffschedule && db.properties.protectionInfo.storageProfileId in SLAoffschedule[dbinfo['SLAPolicy']] ? SLAoffschedule[dbinfo['SLAPolicy']][db.properties.protectionInfo.storageProfileId].schedule : null
                        
                        }
                        var filter = {};
                        filter['property'] = "pk"
                        filter['op'] = "IN" 
                        filter['value'] = []
                        for( var j in db.properties.protectionInfo.storageSnapshots)
                        {
                            filter['value'].push(db.properties.protectionInfo.storageSnapshots[j].storageVolumeId)
                        }
                        snapOption.qs.filter = JSON.stringify([filter])
                        request(snapOption,function(error,response,body)
                        {
                            if(!error && response.statusCode == 200)
                            {
                                var childlists = JSON.parse(body).children
                                var reprpotime = Date.now() - timelen[dbinfo.RepSchedule] * dbinfo.RepFrequency
                                var offrpotime = Date.now() - timelen[dbinfo.OffSchedule] * dbinfo.OffFrequency
                                var repcount = 0
                                var offcount = 0
                                var reptime = 0
                                var offtime = 0
                                var repfail = false
                                var offfail = false
                                for( var k in childlists )
                                {
                                    //need to differentiate offload and replication
                                    if( repfail && offfail ) break
                                    if( childlists[k].properties.replicatedSnapshot.storageType == 'vsnap') 
                                    {
                                        if( childlists[k].properties.sessionId < reprpotime || (childlists[k].properties.pk in replicationerrsession && child_lists[k].properties.sessionId < replicationerrsession[childlists[k].properties.pk]) )
                                        {
                                            repfail = true
                                        }
                                        else
                                        {
                                            if( reptime == 0 ){
                                                reptime = childlists[k].properties.sessionId}
                                            else
                                            {
                                                reptime = Math.min(childlists[k].properties.sessionId,reptime)
                                            }

                                            repcount++;
                                        }
                                    }
                                    else if( childlists[k].properties.replicatedSnapshot.storageType == 'cloud') 
                                    {
                                        if( childlists[k].properties.sessionId < offrpotime || ( childlists[k].properties.pk in offloadsession && child_lists[k].properties.sessionId < offloadsession[childlists[k].properties.pk]) )
                                        {
                                            offfail = true
                                        }
                                        else
                                        {
                                            if( offtime == 0 ){
                                                offtime = childlists[k].properties.sessionId}
                                            else
                                            {
                                                offtime = Math.min(childlists[k].properties.sessionId,offtime)
                                            }

                                            offcount++;
                                        }
                                    }
                                    
                                }
                                if( 'RepSchedule' in dbinfo )
                                {
                                    dbinfo_copy = JSON.parse(JSON.stringify(dbinfo))                                    
                                    if( repcount < filter.value.length )
                                    {
                                        dbinfo_copy['ProtectionTime'] = null
                                        dbinfo_copy['FailureReason'] = "Defined RPO for SLA Policy " + dbinfo_copy.SLAPolicy + " to run Every " + dbinfo_copy.RepFrequency +" " +words[dbinfo_copy.RepSchedule] +" not meet."
                                        replicationresult.ucompliance.push(dbinfo_copy)
                                    }
                                    else
                                    {
                                        dbinfo_copy['ProtectionTime'] = reptime
                                        replicationresult.compliance.push(dbinfo_copy)
                                    }
                                }
                                if( 'OffSchedule' in dbinfo )
                                {
                                    if( offcount < filter.value.length )
                                    {
                                        dbinfo['ProtectionTime'] = null
                                        dbinfo['FailureReason'] = "Defined RPO for SLA Policy " + dbinfo.SLAPolicy + " to run Every " + dbinfo.OffFrequency +" " +words[dbinfo.OffSchedule] +" not meet."
                                        offloadresult.ucompliance.push(dbinfo)
                                    }
                                    else
                                    {
                                        dbinfo['ProtectionTime'] = offtime
                                        offloadresult.compliance.push(dbinfo)
                                    }
                                }
                                resolve() 
                            }
                            else
                            {
                                console.error(error)
                                const err = new Error("Error when getting snapshots")
                                err.status = 403
                                reject(err);
                            }
                        })
                    })
                    promisearray.push(promise)
                }
                return Promise.all(promisearray).then(function(){
                    if( 'nextPage' in links )
                    {
                        option.url = links.nextPage.href
                        return loop()
                    }
                    else
                    {
                        return resolve({'backup2vsnap' : backupresult,'replication':replicationresult,'offload':offloadresult})
                    }
                }).catch(function(error){
                    console.error(error)
                    const err = new Error("Error while getting replication and offload compliance")
                    err.status = 403
                    reject(err);
                })

            }
            else
            {
                console.error(error)
                const err = new Error("Error when getting sucessful backup records")
                err.status = 403
                reject(err);
            }
        })
    }
    return loop()
}
function getdbcompliance(res,req,next)
{
    setSessionandHeader(res,req)
    .then(function(value){
        option.headers['x-endeavour-sessionid'] = value[0]
        snapOption.headers['x-endeavour-sessionid'] = value[0]
        host = value[1]
        snapOption.url= value[1] + '/api/endeavour/catalog/recovery/storagesnapshotreplication?embed=(children(properties))'
        SLAbackschedule = {};
        SLArepschedule = {};
        SLAoffschedule = {};
        replicationerrsession = {};
        offloadsession = {};
        backupresult = {};
    })
    .then(function(){
        return new Promise(function(resolve,reject){
            getstorageprofile(host+storageprofilepath,resolve,reject)
        })
    })
    .then(function(){
        return new Promise(function(resolve,reject){
            gethyperdbs(host+applicationdatabase_path,resolve,reject)
        })
    })
    .then(function(dblists){
        return new Promise(function(resolve,reject){
            getrecoverydbs(dblists,host+database_path,resolve,reject)
        })
    })
    .then(function(){
        return new Promise(function(resolve,reject){
            getdbcompliances(host+applicationdatabase_path,resolve,reject)
        })
    })
    .then(function (result){res.json(result)} )
    .catch(function(error){
        console.log(error)
        next(error)
    })
}


module.exports =
    {
        getdbcompliance : getdbcompliance,
    };

